// debord_intpos.c
#include <stdio.h>

#define CHARU          255   // 8 bits pour 256 valeurs (0...255)
#define SHORTU       65535   // 65536
#define INTU    4294967295   // 2097152 ou 4194304
#define LONGU   4294967295   // 2147483648 ou 4294967296
#define LLONGU 18446744073709551615 // 9223372036854780000 ou le double


int main(int argc, char *argv[])
{
  unsigned int i = 0;

  printf("Test de rebouclage des entiers sans signe\n");

  unsigned char uch = CHARU-2;
  for (i = 1; i<8; i++) {
    printf("+1 dans unsigned char: %u\n", uch);
    uch++;
  }
  unsigned short ush = SHORTU-2;
  for (i = 1; i<8; i++) {
    printf("+1 dans unsigned short : %u\n", ush);
    ush++;
  }
  unsigned int uin = INTU-2;
  for (i = 1; i<8; i++) {
    printf("+1 dans unsigned int: %u\n", uin);
    uin++;
  }
  unsigned long ulo = LONGU-2;
  for (i = 1; i<8; i++) {
    printf("+1 dans unsigned long : %lu\n", ulo);
    ulo++;
  }
  unsigned long long ull = LLONGU-2;
  for (i = 1; i<8; i++) {
    printf("+1 dans unsigned long long : %llu\n", ull);
    ull++;
  }
  uch = 200;
  unsigned char uch2, uch3 = 60;
  uch3 = uch+uch2;
  printf("\nAddition rebouclante de deux uchar : %u + %u = %u\n", uch, uch2, uch3);

  return 0;
}