// f_modproto.c
#include <stdio.h>

void  LaMuette(void);
void  LaParame(int pA);
short LaValeur(void);
short LaMatheuse(int pA, int pB);

int main()
{
  int iValTest;
  printf("// Test des quatre modes avec prototypes.\n");

  LaMuette();
  LaParame(9999);
  iValTest = LaValeur();
  printf("// LaValeur a transmis %d dans main()\n", iValTest);

  iValTest = LaMatheuse(88, 11);
  printf("// LaMatheuse a transmis %d dans main()\n", iValTest);

  printf("// Retour dans main().\n");
  return 0;
}

// Mode 1 : pas de parametres, renvoi de void
void LaMuette(void) { 
  printf("\n // LaMuette vous parle.\n");
  // Pas de return puisque type void 
}

// Mode 2 : un parametre, renvoi de void
void LaParame(int paramA) { 
  printf("\n // LaParame vous parle.\n");
  if (paramA == 9999) printf("  // Action LaParame\n");
  // Pas de return puisque type void 
}

// Mode 3 : pas de parametres, renvoi de valeur
short LaValeur(void) { 
  printf("\n // LaValeur vous parle.\n");
  return(16383);
}

// Mode 4 : parametres et renvoi de valeur
short LaMatheuse(int pA, int pB) { 
  int iMaval;
  printf("\n // LaMatheuse vous parle.\n");
  iMaval = pA + pB;
  return( (short)iMaval);
}
