// lib_math.c
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(void)
{
  char   c_valnum  = -117;
  short  s_valnum  = 16217;
  int    i_valnum  = 16777217;
  double d_valnum  = -1.25125E-4;

  printf("*** Test des fonctions math ***\n");
  i_valnum = c_valnum * s_valnum;
  printf("Valeur absolue de %d = %d\n", c_valnum, abs(c_valnum));
  printf(" abs() de %d = %d\n", i_valnum, abs(i_valnum));

  printf("  abs() de %f = %f\n", d_valnum, abs(d_valnum));
  printf(" fabs() de %f = %f\n", d_valnum, fabs(d_valnum));

  double dBase = 16.0001;
  double dExpo = 5.0, dRes;

// Fonction puissance : pow()
  dRes = pow(dBase, dExpo);
  printf("\n%f puissance %f = %f\n", dBase, dExpo, dRes);

// Fonction racine2: sqrt()
  dBase = 4.0123;
  dExpo = 2.01;
  dRes = pow(dBase, dExpo);
  printf("\n%f puissance %f = %f", dBase, dExpo, dRes);
  dBase = sqrt(dRes);
  printf("\nMais racine carree de %f = %f\n", dRes, dBase);

  dRes = 1.0 / 257.0;
  printf("\nVoici 1/257 : %f ", dRes);
  printf("\nRemultiplions par 257 : perte en ligne car %f \n", dRes*255);

// Fonction modf()
  double x, fractpart, intpart;

  x = 8.123456;
  fractpart = modf(x, &intpart);

  printf("Partie entiere       = %f\n", intpart);
  printf("Partie fractionnaire = %f\n", fractpart);
  
  return 0;
}